<template>
  <div>
    <el-dialog
      v-dialogDrag
      :visible.sync="showEditModal"
      :close-on-click-modal="false"
      width="700px"
      :title="modalTitle"
    >
      <div>
        <Form id="edit-form" ref="formObj" :model="formObj" :rules="ruleValidate" :label-width="80">
          <Form-item label="表单名称" prop="name">
            <el-input v-model="formObj.name" name="name" placeholder="请输入表单名称" clearable />
          </Form-item>
          <Form-item label="表单标识" prop="uri">
            <el-input v-model="formObj.uri" name="uri" placeholder="请输入表单标识，建议最好不要输入中文" clearable />
          </Form-item>
          <Form-item label="备注" prop="remark">
            <el-input v-model="formObj.remark" name="remark" placeholder="请输入备注" clearable />
          </Form-item>
        </Form>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </el-dialog>
  </div>
</template>
<script>
/**
 * 添加编辑表单管理
 */
import { sysForm } from '../../../api'

export default {
  data() {
    return {
      id: '',
      modalTitle: '添加',
      formObj: {
        name: '',
        uri: '',
        remark: ''
      },
      ruleValidate: {
        name: [
          { required: true, message: '表单名称不能为空', trigger: 'blur' }
        ],
        uri: [{ required: true, message: '表单标识不能为空', trigger: 'blur' }]
      },
      showEditModal: false,
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ]
    }
  },
  methods: {
    // modal
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(result, msg) {
      if (result) {
        this.showEditModal = false
        this.$message.success(msg)
        this.$emit('on-result-change')
      }
      this._hideLoading()
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          const data = this.$serialize('edit-form')
          this._save(data)
        } else {
          this.$message.error('表单验证失败')
          this._hideLoading()
        }
      })
    },
    // 添加、编辑保存
    _save: async function(data) {
      // 添加
      if (this.$string(this.id).isEmpty()) {
        const result = await sysForm.add(data)
        this._resultChange(result, '添加成功')
      } else {
        // 编辑
        const result = await sysForm.edit({
          id: this.formObj.id,
          obj: data
        })
        this._resultChange(result, '编辑成功')
      }
    },
    _cancel() {
      this.showEditModal = false
    },
    _open(formObj) {
      this.showEditModal = true
      this.$nextTick(() => {
        this.$refs.formObj.resetFields()
        this._hideLoading()
        if (this.$string(formObj).isEmpty()) {
          this.id = ''
          this.modalTitle = '添加表单'
        } else {
          this.id = formObj.id
          this.formObj = formObj
          this.modalTitle = '编辑表单'
        }
      })
    }
  }
}
</script>
